function Create(self)

	self.laserTimer = Timer();
	self.guideTable = {};
	self.projectileVel = 256;
	if self.Magazine ~= null and self.Magazine.RoundCount ~= 0 then
		self.projectileVel = self.Magazine.NextRound.FireVel;
	end
	self.maxTrajectoryPars = 60;
	self.ScanTimer = Timer();
	self.scanDelay = 100;
	self.maxScanRange = 500;
	self.scanDisruption = 300;
	self.scanSpacing = 10;
	self.numberOfScans = 6;
	self.scanSpreadAngle = 30; -- Degrees!

end

function Update(self)

	if self.ScanTimer:IsPastSimMS(self.scanDelay) then
		self.ScanTimer:Reset();
		local actor = MovableMan:GetMOFromID(self.RootID);
		if MovableMan:IsActor(actor) then
			self.parent = ToActor(actor);
			if self.HFlipped == false then
				self.negativeNum = 1;
			else
				self.negativeNum = -1;
			end
			for x = 1, self.numberOfScans do
				local angleVariance = (-self.scanSpreadAngle*0.5) + (math.random()*self.scanSpreadAngle);
				local terrHitCount = 0;
				local dots = math.floor(self.maxScanRange/self.scanSpacing)
				for i = 1, dots do
					local checkPos = self.MuzzlePos + Vector((self.scanSpacing*i)*self.negativeNum,0):RadRotate(self.RotAngle):DegRotate(angleVariance);
					if SceneMan.SceneWrapsX == true then
						if checkPos.X > SceneMan.SceneWidth then
							checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
						elseif checkPos.X < 0 then
							checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
						end
					end
					local terrCheck = SceneMan:GetTerrMatter(checkPos.X,checkPos.Y);
					if terrCheck ~= 0 then
						terrHitCount = terrHitCount + 1;
					end
				end
				local scanLength = math.floor((self.maxScanRange-(self.scanDisruption*(terrHitCount/dots)))/self.scanSpacing);
				for i = 1, scanLength do
					local checkPos = self.MuzzlePos + Vector((self.scanSpacing*i)*self.negativeNum,0):RadRotate(self.RotAngle):DegRotate(angleVariance);
					if SceneMan.SceneWrapsX == true then
						if checkPos.X > SceneMan.SceneWidth then
							checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
						elseif checkPos.X < 0 then
							checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
						end
					end
					SceneMan:RevealUnseen(checkPos.X,checkPos.Y,self.parent.Team);
				end
			end
		end
	end
	local actor = MovableMan:GetMOFromID(self.RootID);
	if MovableMan:IsActor(actor) and ToActor(actor):IsPlayerControlled() and ToActor(actor):GetController():IsState(Controller.AIM_SHARP) then
		if self.laserTimer:IsPastSimMS(25) then
			self.laserTimer:Reset();

			self.guideTable = {};
			self.guideTable[1] = Vector(self.MuzzlePos.X,self.MuzzlePos.Y);

			local actor = ToActor(actor);
			guideParPos = self.MuzzlePos;
			guideParVel = Vector(self.projectileVel,0):RadRotate(actor:GetAimAngle(true));
			for i = 1, self.maxTrajectoryPars do
				guideParVel = guideParVel + Vector((SceneMan.GlobalAcc.X/FrameMan.PPM),(SceneMan.GlobalAcc.Y/FrameMan.PPM));
				guideParPos = guideParPos + guideParVel;
				if SceneMan.SceneWrapsX == true then
					if guideParPos.X > SceneMan.SceneWidth then
						guideParPos = Vector(guideParPos.X - SceneMan.SceneWidth,guideParPos.Y);
					elseif guideParPos.X < 0 then
						guideParPos = Vector(SceneMan.SceneWidth + guideParPos.X,guideParPos.Y);
					end
				end
				if SceneMan:GetTerrMatter(guideParPos.X,guideParPos.Y) == 0 then
					self.guideTable[#self.guideTable+1] = guideParPos;
				else
					local hitPos = Vector(self.guideTable[#self.guideTable].X,self.guideTable[#self.guideTable].Y);
					SceneMan:CastStrengthRay(self.guideTable[#self.guideTable],SceneMan:ShortestDistance(self.guideTable[#self.guideTable],guideParPos,SceneMan.SceneWrapsX),0,hitPos,3,0,SceneMan.SceneWrapsX);
					self.guideTable[#self.guideTable+1] = hitPos;
					break;
				end
			end
		end
	else
		self.guideTable = {};
	end
	if #self.guideTable > 1 then
		for i = 1, #self.guideTable-1 do
			FrameMan:DrawLinePrimitive(self.guideTable[i],self.guideTable[i+1],120);
		end
		FrameMan:DrawCirclePrimitive(self.guideTable[#self.guideTable],12,120);
	end

end